﻿XIncludeFile #PB_Compiler_Home+"Inc\HID_Module.pbi"

;- Window Constants
;
Enumeration
  #Main_Window
EndEnumeration

;- Gadget Constants
;
Enumeration
  #Text_Device_list
  #ListIcon_Device
  #Text_Log
  #Button_Start
  #Button_Stop
  #Text_Selected_device
  #String_Selected_device
  #Container_Data
  #Option_Random
  #Option_SelectData
  #CheckBox_ReadDevice_State = #Option_SelectData + 17
  #Text_Pause
  #String_Pause
  #Editor_Log
  #Button_UpdateDeviceList
EndEnumeration


Structure Thread_Device_IO_Info
  ReadDevice_State.b
  Pause.l
  DeviceInfo.HID::HID_CAPS
  RandomState.b
  Bytes.u[10]
EndStructure

Global PID_Device.u, VID_Device.u, VersionNumber_Device.u, DeviceHandle=0

Thread_Device_Info.Thread_Device_IO_Info



Procedure HID_DeviceInfo(*x)
  Protected HID_Info.HID::HID_DeviceInfo
  Protected Hid_Count=0
  
  If HID::DeviceInfo(@HID_Info)
    If HID_Info\CountDevice>0 And Hid_Count<>HID_Info\CountDevice
      Hid_Count=HID_Info\CountDevice
      ClearGadgetItems(#ListIcon_Device)
      For i=0 To HID_Info\CountDevice-1
        AddGadgetItem(#ListIcon_Device,i,HID_Info\DeviceInfo[i]\Product)
        SetGadgetItemText(#ListIcon_Device,i,Hex(HID_Info\DeviceInfo[i]\ProductID,#PB_Unicode)+"H",1)
        SetGadgetItemText(#ListIcon_Device,i,Str(HID_Info\DeviceInfo[i]\ProductID),7)
        SetGadgetItemText(#ListIcon_Device,i,Hex(HID_Info\DeviceInfo[i]\VendorID,#PB_Unicode)+"H",2)
        SetGadgetItemText(#ListIcon_Device,i,Str(HID_Info\DeviceInfo[i]\VendorID),8)
        SetGadgetItemText(#ListIcon_Device,i,Hex(HID_Info\DeviceInfo[i]\VersionNumber,#PB_Unicode)+"H",3)
        SetGadgetItemText(#ListIcon_Device,i,Str(HID_Info\DeviceInfo[i]\VersionNumber),9)
        SetGadgetItemText(#ListIcon_Device,i,Str(HID_Info\DeviceInfo[i]\InputReportByteLength),4)
        SetGadgetItemText(#ListIcon_Device,i,Str(HID_Info\DeviceInfo[i]\OutputReportByteLength),5)
        SetGadgetItemText(#ListIcon_Device,i,Str(HID_Info\DeviceInfo[i]\FeatureReportByteLength),6)
      Next i
    EndIf
  EndIf
  
EndProcedure

Procedure Disables_Gadgets(State)
  DisableGadget(#Button_Start, State)
  DisableGadget(#Button_Stop, State!1)
  DisableGadget(#ListIcon_Device, State)
  DisableGadget(#String_Pause, State)
  DisableGadget(#Container_Data, State)
  DisableGadget(#CheckBox_ReadDevice_State, State)
EndProcedure

Procedure FindDevice_Timer() ; Процедура вызывается по таймеру, каджие 200 мс.
  Static Old_Test
  Shared FindDevice_Ignore
  Shared Thread_Device_IO_Bugs, Thread_Device_IO_ID
  
  If PID_Device<>0 And VID_Device<>0
    Test=HID::TestDevice(PID_Device, VID_Device, VersionNumber_Device) ; Проверка доступности HID устройства
    If Test<>Old_Test Or FindDevice_Ignore=1
      FindDevice_Ignore=0
      Old_Test=Test
      If Test 
        HID::CloseDevice(DeviceHandle) ; Освобождение хендлов, если таковые есть
        ; Получение идентификаторов HID устройства
        DeviceHandle=HID::OpenDevice(PID_Device, VID_Device, VersionNumber_Device) ; Хендл для записи
        If DeviceHandle
          SetGadgetColor(#String_Selected_device, #PB_Gadget_FrontColor, RGB(64, 140, 76))
        Else
          SetGadgetColor(#String_Selected_device, #PB_Gadget_FrontColor, RGB(190, 0, 0))
        EndIf
      Else
        HID::CloseDevice(W_DeviceHandle) ; Освобождение хендлов, если таковые есть
        DeviceHandle=0
        SetGadgetColor(#String_Selected_device, #PB_Gadget_FrontColor, RGB(190, 0, 0))
      EndIf
    EndIf
  EndIf
  
  If Thread_Device_IO_ID 
    If Thread_Device_IO_Bugs>4
      Disables_Gadgets(0)
      If IsThread(Thread_Device_IO_ID)
        KillThread(Thread_Device_IO_ID)
        Thread_Device_IO_ID = 0
        MessageRequester("", "Thread is not responding!"+Chr(10)+"This is probably caused by bug"+Chr(10)+"connection with USB HID device!"+Chr(10)+Chr(10)+"Thread is killed!", 16)
      Else
        Thread_Device_IO_Bugs=0
      EndIf 
    Else
      Thread_Device_IO_Bugs+1
    EndIf
  EndIf
EndProcedure


Procedure.s ByteToString(*Point, Size)
  Protected String.s
  String = ""
  For i=0 To Size
    String+RSet(Hex(PeekA(*Point+i), #PB_Ascii), 2, "0")+" "
  Next i
  ProcedureReturn String
EndProcedure

Procedure Thread_Device_IO(*Point)
  Shared Thread_Start, Thread_Device_IO_ID
  Shared Thread_Device_IO_Bugs, FindDevice_Ignore
  Protected StructInfo.Thread_Device_IO_Info
  CopyMemory(*Point, @StructInfo, SizeOf(Thread_Device_IO_Info))
  
  InputReport = StructInfo\DeviceInfo\InputReportByteLength
  OutputReport = StructInfo\DeviceInfo\OutputReportByteLength
  Feature =  StructInfo\DeviceInfo\FeatureReportByteLength
  
  Dim OutBuf.a(OutputReport+2)
  Dim InBuf.a(InputReport+2)
  
  CompareMem=InputReport
  If OutputReport < InputReport
    CompareMem = OutputReport
  EndIf
  
  Counter = 1
  Counter_x=Counter+99;9 
  Repeat
    
    If DeviceHandle
       FillMemory(@OutBuf(), OutputReport, 0, #PB_Byte)
       FillMemory(@InBuf(), InputReport, 0, #PB_Byte)
       
       If StructInfo\RandomState = 1
         Temp1=8
         If OutputReport<8
           Temp1=OutputReport
         EndIf
         For z=1 To Temp1
           
           If StructInfo\Bytes[z] >255
             Temp.a=Random(255)
           Else
             Temp.a=StructInfo\Bytes[z]
           EndIf
           OutBuf(z) = Temp
         Next z
       Else
         For z=1 To OutputReport
           Temp.a=Random(255)
           OutBuf(z) = Temp
         Next z
       EndIf
       
       OutCount=HID::WriteDevice(DeviceHandle, @OutBuf(),OutputReport)

       If OutCount = OutputReport
         If StructInfo\ReadDevice_State = 1
           InCount=HID::ReadDevice(DeviceHandle, @InBuf(),InputReport)
           If InCount = InputReport
             If CompareMem<>0 And CompareMemory(@OutBuf(), @InBuf(), CompareMem)<>1
               AddGadgetItem(#Editor_Log, -1, RSet(Str(Counter), 6, " ")+"  ERROR    Bug compare memory  Send: "+ByteToString(@OutBuf()+1, CompareMem-2)+";    Read: "+ByteToString(@InBuf()+1, CompareMem-2))
               Break
             EndIf
           Else
             AddGadgetItem(#Editor_Log, -1, RSet(Str(Counter), 6, " ")+"  ERROR    Bug read device (read "+Str(InCount)+" bytes)  Send: "+ByteToString(@OutBuf()+1, OutputReport-2)+";    Read: "+ByteToString(@InBuf()+1, InputReport-2))
             Break
           EndIf
         EndIf
       Else
         AddGadgetItem(#Editor_Log, -1, RSet(Str(Counter), 6, " ")+"  ERROR    Bug write device (send "+Str(OutCount)+" bytes).  Send: "+ByteToString(@OutBuf()+1, OutputReport-2));"
         Break
       EndIf
       
       
       
       
;        OutCount=HID::SetFeature(DeviceHandle, @OutBuf(),Feature)
; 
;        If OutCount = 1
;          If StructInfo\ReadDevice_State = 1
;            InCount=HID::GetFeature(DeviceHandle, @InBuf(),Feature)
;            If InCount = 1
;              If Feature<>0 And CompareMemory(@OutBuf(), @InBuf(), Feature)<>1
;                AddGadgetItem(#Editor_Log, -1, RSet(Str(Counter), 6, " ")+"  ERROR    Bug compare memory  Send: "+ByteToString(@OutBuf()+1, Feature-2)+";    Read: "+ByteToString(@InBuf()+1, Feature-2))
;                Break
;              EndIf
;            Else
;              AddGadgetItem(#Editor_Log, -1, RSet(Str(Counter), 6, " ")+"  ERROR    Bug read device (read "+Str(InCount)+" bytes)  Send: "+ByteToString(@OutBuf()+1, Feature-2)+";    Read: "+ByteToString(@InBuf()+1, Feature-2))
;              Break
;            EndIf
;          EndIf
;        Else
;          AddGadgetItem(#Editor_Log, -1, RSet(Str(Counter), 6, " ")+"  ERROR    Bug write device (send "+Str(OutCount)+" bytes).");  Send: "+ByteToString(@OutBuf()+1, OutputReport-2)
;          Break
;        EndIf
       
       If Counter_x<=Counter
       AddGadgetItem(#Editor_Log, -1, RSet(Str(Counter), 6, " ")+"  OK    Send: "+ByteToString(@OutBuf()+1, OutCount-2))
       SendMessage_(GadgetID(#Editor_Log), #EM_SETSEL, -1, -1)
       Counter_x+100;0
       EndIf
    EndIf 
    
    If StructInfo\Pause>10
      Delay(StructInfo\Pause)
    EndIf
    
    Thread_Device_IO_Bugs = 0
    Counter + 1
  Until Thread_Start<>1 Or DeviceHandle = 0
  SendMessage_(GadgetID(#Editor_Log), #EM_SETSEL, -1, -1)
  Disables_Gadgets(0)
  FindDevice_Ignore = 1
  Thread_Device_IO_ID = 0
EndProcedure

Procedure Open_Main_Window()
  If OpenWindow(#Main_Window, 241, 107, 596, 520, "USB HID Tester",  #PB_Window_MinimizeGadget | #PB_Window_Invisible | #PB_Window_TitleBar | #PB_Window_ScreenCentered )
      TextGadget(#Text_Device_list, 5, 5, 280, 15, "Device list:")
      ButtonGadget(#Button_UpdateDeviceList, 510,2,80,18,"Update")
      ListIconGadget(#ListIcon_Device, 5, 20, 585, 100, "Product", 58, #PB_ListIcon_GridLines|#PB_ListIcon_FullRowSelect|#PB_ListIcon_HeaderDragDrop|#PB_ListIcon_AlwaysShowSelection)
         AddGadgetColumn(#ListIcon_Device,1,"PID",48)
         AddGadgetColumn(#ListIcon_Device,2,"VID",48)
         AddGadgetColumn(#ListIcon_Device,3,"Version Number",94)
         AddGadgetColumn(#ListIcon_Device,4,"Imput report (bytes)",110)
         AddGadgetColumn(#ListIcon_Device,5,"Output report (bytes)",114)
         AddGadgetColumn(#ListIcon_Device,6,"Feature (bytes)",90)
         AddGadgetColumn(#ListIcon_Device,7,"",0)
         AddGadgetColumn(#ListIcon_Device,8,"",0)
         AddGadgetColumn(#ListIcon_Device,9,"",0)
      TextGadget(#Text_Selected_device, 5, 130, 100, 15, "Selected device:")
      StringGadget(#String_Selected_device, 110, 125, 480, 20, "", #PB_String_ReadOnly)
      ContainerGadget(#Container_Data,5,150,585,50,#PB_Container_Flat)
         OptionGadget(#Option_Random,4,6,90,15,"Random data") : SetGadgetState(#Option_Random,1)
         OptionGadget(#Option_SelectData,4,26,80,15,"Select data")
         
         Pos=100
         For i=#Option_SelectData+1 To #Option_SelectData+16 Step 2
           TextGadget(i, Pos, 28, 10, 15, Str((i-#Option_SelectData+2)/2)) : DisableGadget(i, 1)
           StringGadget(i+1, Pos+10, 24, 30, 20, "0", #PB_String_Numeric|#PB_Text_Center) : DisableGadget(i+1, 1)
           SetGadgetAttribute(i+1, #PB_String_MaximumLength, 3)
           Pos+58
         Next i
      CloseGadgetList()
      
      
      TextGadget(#Text_Log, 5, 165+50, 30, 15, "Log:") : SetGadgetColor(#Text_Log, #PB_Gadget_FrontColor, RGB(0, 0, 235))
      ButtonGadget(#Button_Start, 440, 155+50, 75, 25, "Start")
      ButtonGadget(#Button_Stop, 530, 155+50, 60, 25, "Stop") : DisableGadget(#Button_Stop, 1)
      EditorGadget(#Editor_Log, 5, 185+50, 585, 280, #PB_Editor_ReadOnly)
         SetGadgetFont(#Editor_Log, LoadFont(0, "Lucida Console", 8))
      CheckBoxGadget(#CheckBox_ReadDevice_State, 50, 165+50, 135, 15, "Read data from device")
      TextGadget(#Text_Pause, 210, 165+50, 145, 15, "Pause between packets, ms:")
      StringGadget(#String_Pause, 360, 160+50, 40, 20, "0", #PB_String_Numeric)
       SetGadgetAttribute(#String_Pause, #PB_String_MaximumLength, 3)
  EndIf
EndProcedure

HID::HID_Init()

Open_Main_Window()
AddWindowTimer(#Main_Window, 1, 800)
;HID_DeviceInfo(0)
Th_FindDevice=CreateThread(@HID_DeviceInfo(), 0)
For i=1 To 20
  WaitWindowEvent(1)
Next i
HideWindow(#Main_Window, #False)

Repeat
  Event=WaitWindowEvent()
  
  If Event=#PB_Event_Timer
    Select EventTimer()
      Case 1
        FindDevice_Timer()
      ;Case 2
    EndSelect
    
    
  ElseIf Event=#PB_Event_Gadget
    Select EventGadget()
        
      Case  #Button_UpdateDeviceList
        HID_DeviceInfo(0)
      Case #ListIcon_Device
        If EventType()=#PB_EventType_LeftDoubleClick
          ListPos=GetGadgetState(#ListIcon_Device)
          If ListPos>=0
            HID::CloseDevice(W_DeviceHandle)
            DeviceHandle=0
            PID_Device = Val(GetGadgetItemText(#ListIcon_Device, ListPos, 7))
            VID_Device = Val(GetGadgetItemText(#ListIcon_Device, ListPos, 8))
            VersionNumber_Device = Val(GetGadgetItemText(#ListIcon_Device, ListPos, 9))
            SetGadgetColor(#String_Selected_device, #PB_Gadget_FrontColor, #PB_Default)
            SetGadgetText(#String_Selected_device, GetGadgetItemText(#ListIcon_Device, ListPos, 0)+";  PID: "+Hex(PID_Device,#PB_Unicode)+"H"+";  VID: "+Hex(VID_Device,#PB_Unicode)+"H"+";  S/N: "+Hex(VersionNumber_Device,#PB_Unicode)+"H")
            FindDevice_Ignore=1
          EndIf
        EndIf
        
        
      Case #Button_Start
       If DeviceHandle
         Thread_Start=1
          Thread_Device_Info\ReadDevice_State=GetGadgetState(#CheckBox_ReadDevice_State)
          Thread_Device_Info\Pause=Val(GetGadgetText(#String_Pause))
          If Thread_Device_Info\Pause<0
            Thread_Device_Info\Pause=0
          ElseIf Thread_Device_Info\Pause > 1000
            Thread_Device_Info\Pause = 1000
          EndIf
          HID::GetCaps(DeviceHandle, @Thread_Device_Info\DeviceInfo)
          Thread_Device_Info\RandomState = GetGadgetState(#Option_Random) ! 1
          If Thread_Device_Info\RandomState = 1
            For i=#Option_SelectData+1 To #Option_SelectData+16 Step 2
              Thread_Device_Info\Bytes[(i-#Option_SelectData+2)/2] = Val(GetGadgetText(i+1))
            Next i
          EndIf
          Thread_Device_IO_Bugs=0
          ClearGadgetItems(#Editor_Log)
          Thread_Device_IO_ID=CreateThread(@Thread_Device_IO(), @Thread_Device_Info)
          If Thread_Device_IO_ID
            Disables_Gadgets(1)
          Else 
            MessageRequester("", "An error occurred when starting a thread!", 16)
          EndIf
        Else
          If GetGadgetText(#String_Selected_device)=""
            MessageRequester("", "Select a device from the list."+Chr(10)+"(Double click the left mouse button).", 48)
          Else
            MessageRequester("", "No devices found with the specified PID & VID", 48)
          EndIf
        EndIf 
        
        
      Case #Button_Stop
        If Thread_Device_IO_ID<>0
          Thread_Start+1
          If Thread_Start>4
            If IsThread(Thread_Device_IO_ID)
              KillThread(Thread_Device_IO_ID)
            EndIf
            Thread_Device_IO_Bugs=0
            Thread_Start=0
            Disables_Gadgets(0)
            MessageRequester("", "Thread is not responding!"+Chr(10)+"This is probably caused by an bug"+Chr(10)+"connection withUSB HID device!"+Chr(10)+Chr(10)+"Thread is killed.", 48)
          EndIf
        Else
          Disables_Gadgets(0)
          Thread_Start = 0
        EndIf
        
        
      Case #Option_Random, #Option_SelectData
        State=GetGadgetState(#Option_Random)
        For i=#Option_SelectData+1 To #Option_SelectData+16
           DisableGadget(i, State)
        Next i
    EndSelect
  EndIf
  
  
Until Event=#PB_Event_CloseWindow

If IsThread(Th_FindDevice)
  KillThread(Th_FindDevice)
EndIf

If IsThread(Thread_Device_IO_ID)
  KillThread(Thread_Device_IO_ID)
EndIf

HID::HID_End()
; IDE Options = PureBasic 5.70 LTS (Windows - x86)
; Folding = --
; EnableThread
; EnableXP
; CompileSourceDirectory