﻿XIncludeFile #PB_Compiler_Home+"Inc\MyGrid.pbi"

EnableExplicit

Enumeration 
  #Win_Nbr
  #Grid_Nbr
  #Grid_PopupMenu
  #MenuItem_1
  #MenuItem_2
  #MenuItem_3
  #MenuItem_4
  #MenuItem_5
  #Cntr_Nbr
  #Btn_Save
  #Btn_Load
  #Btn_Sort
EndEnumeration

Global i,j,r,c,s.s, EvGd, Evnt, EvTp, EvMn, txt.s, NewList lst.s()
Global Font_A16    = LoadFont(#PB_Any, "Arial", 16)
Global Dim Images(2)

UsePNGImageDecoder()
Images(0) = LoadImage(#PB_Any, "..\sources\Data\world.png")
Images(1) = LoadImage(#PB_Any, "..\sources\Data\file.bmp")
Images(2) = LoadImage(#PB_Any, "..\sources\Data\PureBasic.bmp")

Procedure.s random_text(max_len)
  Protected   txt.s, buf.s = "ABCDEFGHIJKLMNOPQRSTUVWXYZ" + "abcdefghijklmnopqrstuvwxyz" + " 0123456789"
  Protected   i, n = Len(buf), j = Random(max_len)
  
  For i=1 To j
    txt + Mid(buf, Random(n,1), 1)
  Next
  ProcedureReturn txt
  
EndProcedure

Procedure Resize()
  ResizeGadget(#Cntr_Nbr, WindowWidth(#Win_Nbr) - 80, #PB_Ignore, #PB_Ignore, #PB_Ignore)
  MyGrid::Resize(#Grid_Nbr, #PB_Ignore, #PB_Ignore, WindowWidth(#Win_Nbr) - 100, WindowHeight(#Win_Nbr) - 20)
EndProcedure

If OpenWindow(#Win_Nbr, 0, 0, 800, 400, "MyGrid", #PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget | #PB_Window_ScreenCentered | #PB_Window_SizeGadget | #PB_Window_Invisible)
  SmartWindowRefresh(#Win_Nbr, #True)
  SetWindowColor(#Win_Nbr,#White)
  
  If CreatePopupMenu(#Grid_PopupMenu)      ; creation of the pop-up menu begins...
    MenuItem(#MenuItem_1, "Copy")
    MenuItem(#MenuItem_2, "Paste")
    MenuBar()
    MenuItem(#MenuItem_3, "Show")
    MenuItem(#MenuItem_4, "Hide")
    MenuItem(#MenuItem_5, "Freeze here")
  EndIf
  
  r = 200 : c = 50
  MyGrid::New(#Win_Nbr, #Grid_Nbr, 10, 10, 700, 380, r, c, #False)
  
  ContainerGadget(#Cntr_Nbr, 720, 10, 80, 380, #PB_Container_Flat)
  SetGadgetColor(#Cntr_Nbr, #PB_Gadget_BackColor, #White)
  ButtonGadget(#Btn_Save, 5, 10, 70, 20,"Save to txt")
  ButtonGadget(#Btn_Load, 5, 40, 70, 20,"Load from txt")
  ButtonGadget(#Btn_Sort, 5, 70, 70, 20,"Multi-Sort")
  CloseGadgetList()
  
  ; ---- names of builtin styles - ready to use by name
  ; "Default", "HeaderGradient", "Header", "HeaderLeft", "HeaderRight"
  ; "Center", "Left", "Right", "EditLeft", "EditRight", "EditCenter"
  ; "Extra", "Detail", "Checkbox", "Combo", "Button", "Image", "ImageFit"
  
  For i = 1 To MyGrid::GetRowCount(#Grid_Nbr)
    MyGrid::SetText(#Grid_Nbr, i, 3, Str(Random(1000)))
    MyGrid::SetText(#Grid_Nbr, i, 4, random_text(5))
    MyGrid::SetText(#Grid_Nbr, i, 5, random_text(40))
    MyGrid::SetText(#Grid_Nbr, i, 6, StrF(Random(1000) / 100.0, 2))
    MyGrid::SetText(#Grid_Nbr, i, 9, "Button " + Str(i))
    MyGrid::SetText(#Grid_Nbr, i,10, Str(Images(Random(2))))            ; any one of the 3 loaded images
    MyGrid::SetText(#Grid_Nbr, i,11, Str(Images(Random(2))))            ; any one of the 3 loaded images
  Next
  
  ; customizing headers
  MyGrid::AssignStyle(#Grid_Nbr, MyGrid::#RC_Header, MyGrid::#RC_Any, "Header")
  MyGrid::AssignStyle(#Grid_Nbr, MyGrid::#RC_Any, MyGrid::#RC_Header, "Header")
  
  MyGrid::SetText(#Grid_Nbr, 0, 1, "Editable Center")
  MyGrid::SetText(#Grid_Nbr, 0, 2, "Editable Left")
  MyGrid::SetText(#Grid_Nbr, 0, 3, "Click to Sort")
  MyGrid::SetText(#Grid_Nbr, 0, 4, "Click to Sort")
  MyGrid::SetText(#Grid_Nbr, 0,10, "Image")
  MyGrid::SetText(#Grid_Nbr, 0,11, "Fit Image")
  MyGrid::SetRowHeight(#Grid_Nbr, 0, 2 * MyGrid::#Default_RowHeight)
  
  
  ; defining style for columns (can de defined for rows/cells as well...)
  MyGrid::AssignStyle(#Grid_Nbr, MyGrid::#RC_Data, 1, "EditCenter")  ; assign to data-cells in col# 1 editable center-alignment
  MyGrid::AssignStyle(#Grid_Nbr, MyGrid::#RC_Data, 2, "EditLeft")    ; assign to data-cells in col# 2 editable left-alignment
  MyGrid::AssignStyle(#Grid_Nbr, MyGrid::#RC_Data, 3, "Right")       ; assign to data-cells in col# 3 non-editable right-alignment
  MyGrid::AssignStyle(#Grid_Nbr, MyGrid::#RC_Data, 4, "EditCenter")  ; assign to data-cells in col# 4 editable center-alignment
  MyGrid::AssignStyle(#Grid_Nbr, MyGrid::#RC_Data, 6, "EditRight")   ; assign to data-cells in col# 6 editable right-alignment
  MyGrid::AssignStyle(#Grid_Nbr, MyGrid::#RC_Data, 7, "Checkbox")    ; assign to data-cells in col# 7 default checkbox
  MyGrid::AssignStyle(#Grid_Nbr, MyGrid::#RC_Data, 8, "Combo")       ; assign to data-cells in col# 8 default combo
  MyGrid::AssignStyle(#Grid_Nbr, MyGrid::#RC_Data, 9, "Button")      ; assign to data-cells in col# 8 default Button
  MyGrid::AssignStyle(#Grid_Nbr, MyGrid::#RC_Data,10, "Image")       ; assign to data-cells in col# 8 default Image
  MyGrid::AssignStyle(#Grid_Nbr, MyGrid::#RC_Data,11, "ImageFit")    ; assign to data-cells in col# 8 default ImageFit (resize image)
  
  ; customizing a builtin style
  MyGrid::SetStyleItems(#Grid_Nbr, "Combo", "A,B,C,D,AA,BBB,CCC,ABCD,EF,XXX,AAA,ZZZ", ",")
  MyGrid::SetStyleForeColor(#Grid_Nbr, "Combo", $2A2AA5)
  
  ; hiding col 15 and row 17 ... for good user cannot un-hide via resizing
  MyGrid::HideCol(#Grid_Nbr,15, 1)
  MyGrid::HideRow(#Grid_Nbr,17, 1)
  
  ; enabling sort-on-click for cols: 3, 4, 6
  MyGrid::EnableSortOnClick(#Grid_Nbr, 3)
  MyGrid::EnableSortOnClick(#Grid_Nbr, 4)
  MyGrid::EnableSortOnClick(#Grid_Nbr, 6)
  
  MyGrid::AttachPopup(#Grid_Nbr, #Grid_PopupMenu)
  
  ; adding a new custom-style
  MyGrid::AddNewStyle(#Grid_Nbr, "BlueYellowRight")   ; at creation its is a replica of the default style
  MyGrid::SetStyleAlign(#Grid_Nbr, "BlueYellowRight", MyGrid::#Align_Right)
  MyGrid::SetStyleBackColor(#Grid_Nbr, "BlueYellowRight", #Yellow)
  MyGrid::SetStyleForeColor(#Grid_Nbr, "BlueYellowRight", #Blue)
  MyGrid::SetStyleFont(#Grid_Nbr, "BlueYellowRight", LoadFont(#PB_Any, "Veradna", 14))
  MyGrid::SetStyleEditable(#Grid_Nbr, "BlueYellowRight", #True)
  
  ; assigning this custom style to some cells:
  ; styles assigned at cell levels will overwrite styles assigned at higher levels (at row/ col/...)
  MyGrid::AssignStyle(#Grid_Nbr, 3, 1, "BlueYellowRight")
  MyGrid::AssignStyle(#Grid_Nbr, 7, 2, "BlueYellowRight")
  MyGrid::AssignStyle(#Grid_Nbr, 9, 5, "BlueYellowRight")
  
  ; <<<--------------- Hiding Focus Rectangle ------------------------>>>
  ; Example: to hide focus-rectangle,. change its color to -1 / ozzie / un-comment below line
  ;MyGrid::SetColorAttribute(#Grid_Nbr, #MyGrid::Color_FocusBorder, -1)
  
  MyGrid::Redraw(#Grid_Nbr)
  
  MyGrid::AutoHeightRow(#Grid_Nbr, 1)
  MyGrid::AutoHeightRow(#Grid_Nbr, 2)
  MyGrid::AutoHeightRow(#Grid_Nbr, 9)
  
  BindEvent(#PB_Event_SizeWindow, @Resize(), #Win_Nbr)
  
  HideWindow(#Win_Nbr, #False)
  
  Repeat
    EvGd = -1
    EvTp = -1
    EvMn = -1
    Evnt = WaitWindowEvent()
    Select Evnt
        
      Case MyGrid::#Event_Change
        r = MyGrid::GetChangedRow(EventGadget())
        c = MyGrid::GetChangedCol(EventGadget())
        Debug " ... Change occured in Cell (" + Str(r) +","+ Str(c) + ") old text: >>" + MyGrid::GetChangedText(EventGadget()) + "<< and new text: >>" + MyGrid::GetText(EventGadget(), r, c) +"<<"
        
      Case MyGrid::#Event_Click
        r = MyGrid::GetClickedRow(EventGadget())
        c = MyGrid::GetClickedCol(EventGadget())
        Debug " ... Button clicked in Cell (" + Str(r) +","+ Str(c) + ")"
        
;       Case #PB_Event_SizeWindow
;         ResizeGadget(#Cntr_Nbr, WindowWidth(#Win_Nbr) - 80, #PB_Ignore, #PB_Ignore, #PB_Ignore)
;         MyGrid::Resize(#Grid_Nbr, #PB_Ignore, #PB_Ignore, WindowWidth(#Win_Nbr) - 100, WindowHeight(#Win_Nbr) - 20)
        
      Case #PB_Event_Gadget 
        EvGd = EventGadget()
        EvTp = EventType()
        Select EvGd
          Case #Btn_Save
            txt = OpenFileRequester("Save", GetTemporaryDirectory() + "MyGrid.TXT", "Text (*.txt)|*.txt;*.bat|All files (*.*)|*.*",0)
            If txt <> ""
              MyGrid::SaveToTextFile(#Grid_Nbr, #TAB$, lst(), txt)
            EndIf
            
          Case #Btn_Sort
            MessageRequester("Sort","the grid will be sorted on col 6 (asc) and then col 4 (desc)")
            MyGrid::ResetSort(#Grid_Nbr)
            MyGrid::AddSortingCol(#Grid_Nbr, 6, #PB_Sort_Ascending)
            MyGrid::AddSortingCol(#Grid_Nbr, 4, #PB_Sort_Descending)
            MyGrid::Sort(#Grid_Nbr)
            
            
        EndSelect
        
      Case #PB_Event_Menu
        EvMn = EventMenu()
        Select EvMn
          Case #MenuItem_1 :
            SetClipboardText(MyGrid::GetBlockText(#Grid_Nbr))
            MessageRequester("Copy","Selected block copied to clipboard")
          Case #MenuItem_2 : 
            MyGrid::SetBlockText(#Grid_Nbr, GetClipboardText())
            
          Case #MenuItem_3 : Debug " popup menu 3 "
          Case #MenuItem_4 : Debug " popup menu 4 "
          Case #MenuItem_5 : Debug " popup menu 5 "
        EndSelect
        
    EndSelect
    
    
  Until  Evnt = #PB_Event_CloseWindow
EndIf
; IDE Options = PureBasic 5.70 LTS (Windows - x86)
; Folding = -
; EnableXP
; CompileSourceDirectory