XIncludeFile #PB_Compiler_Home+"Inc\PureAutoIt.pbi"
UseModule PureAutoIt

Procedure MyAdLibFunc()
  ; Assign a static variable to hold the number of times the function is called.
  Static iCount = 0
  iCount + 1

  Debug "MyAdLibFunc called " + iCount + " time(s)"
EndProcedure

Procedure Example()
  ; Register the function MyAdLibFunc() to be called every 250ms (default).
  AdlibRegister(@MyAdLibFunc())

  ; Sleep does not stop AdLib functions from running.
  Sleep(1000)

  ; AdLib functions don't run while a blocking function is shown e.g. MsgBox, InputBox, WinWait, WinWaitClose etc.
  MsgBox(#MB_SYSTEMMODAL, "", "No console message(s) will be shown whilst the messagebox is displayed. (not true for PureAutoIt :q)")

  ; The AdLib function MyAdLibFunc() will start again.
  Sleep(2000)

  ; Unregister the function MyAdLibFunc() from being called every 250ms.
  AdlibUnRegister(@MyAdLibFunc())
EndProcedure

Example()
