XIncludeFile #PB_Compiler_Home+"Inc\PureAutoIt.pbi"
UseModule PureAutoIt

; Create a file.
Procedure FileCreate(sFilePath.s, sString.s)
  fReturn = #True ; Create a variable to store a boolean value.
  If Not FileExists(sFilePath)
    fReturn = FileWrite(sFilePath, sString)
  EndIf
  ProcedureReturn fReturn
EndProcedure

Procedure Example()
  ; Create a constant variable in Local scope of the filepath that will be read/written to.
  sFilePath.s = _TempDir() + "\FileCreateNTFSLink.txt"

  ; Create a temporary file to link to.
  If Not FileCreate(sFilePath, "This is an example of using FileCreateNTFSLink.")
    ProcedureReturn MsgBox(#MB_SYSTEMMODAL, "", "An error occurred whilst writing the temporary file.")
  EndIf

  ; Create a NTFS link of the .txt file to the .log file on the desktop.
  iNTFSLink = FileCreateNTFSLink(sFilePath, _DesktopDir() + "\ExampleNTFSLink.log")

  ; Display a message of whether the NTFS link was created.
  If iNTFSLink
    ; Open the desktop directory.
    ShellExecute(_DesktopDir())

    MsgBox(#MB_SYSTEMMODAL, "", "The NTFS link was created." + #CRLF$ + "FileCreateNTFSLink returned: " + iNTFSLink)
  Else
    MsgBox(#MB_SYSTEMMODAL, "", "The NTFS link wasn't created." + #CRLF$ + "FileCreateNTFSLink returned: " + iNTFSLink)
  EndIf

  ; Delete the temporary files.
  FileDelete(sFilePath)
  FileDelete(_DesktopDir() + "\ExampleNTFSLink.log")
EndProcedure

Example()
