XIncludeFile #PB_Compiler_Home+"Inc\PureAutoIt.pbi"
UseModule PureAutoIt

; Create a file.
Procedure FileCreate(sFilePath.s, sString.s)
  fReturn = #True ; Create a variable to store a boolean value.
  If Not FileExists(sFilePath)
    fReturn = FileWrite(sFilePath, sString)
  EndIf
  ProcedureReturn fReturn
EndProcedure

Procedure Example()
  ; Create a constant variable in Local scope of the filepath that will be read/written to.
  sFilePath.s = _TempDir() + "\FileDelete.txt"

  ; Create a temporary file to read data from.
  If Not FileCreate(sFilePath, "This is an example of using FileDelete.")
    ProcedureReturn MsgBox(#MB_SYSTEMMODAL, "", "An error occurred whilst writing the temporary file.")
  EndIf

  ; Display the contents of the file passing the filepath to FileRead instead of a handle returned by FileOpen.
  MsgBox(#MB_SYSTEMMODAL, "", "Contents of the file:" + #CRLF$ + FileRead(sFilePath))

  ; Delete the temporary file.
  iDelete = FileDelete(sFilePath)

  ; Display a message of whether the file was deleted.
  If iDelete
    MsgBox(#MB_SYSTEMMODAL, "", "The file was successfuly deleted.")
  Else
    MsgBox(#MB_SYSTEMMODAL, "", "An error occurred whilst deleting the file.")
  EndIf
EndProcedure

Example()
