XIncludeFile #PB_Compiler_Home+"Inc\PureAutoIt.pbi"
UseModule PureAutoIt

Procedure Display(sInput.s, sOutput.s)
  ; Format the output.
  sMsg.s = StringFormat("Input:\t%s\n\nOutput:\t%s", @sInput, @sOutput)
  MsgBox(#MB_SYSTEMMODAL, "Results", sMsg)
EndProcedure   ;==>Display

; This example demonstrates a basic replacement.  It replaces the vowels aeiou
; with the @ character.
Procedure Test1()
  sInput.s = "Where have all the flowers gone, long time passing?"
  sOutput.s = StringRegExpReplace(sInput, "[aeiou]", "@")
  Display(sInput, sOutput)
EndProcedure

; The following example demonstrates using back-references to change the date
; from MM/DD/YYYY to DD.MM.YYYY
Procedure Test2()
  sInput.s = "some text1 12/31/2009 01:02:03 some text2" + #CRLF$ +
      "some text3 02/28/2009 11:22:33 some text4"
  sOutput.s = StringRegExpReplace(sInput, "(\d{2})/(\d{2})/(\d{4})", " 2.1.3 ")
  Display(sInput, sOutput)
EndProcedure

; The following example demonstrates the need to double backslash
Procedure Test3()
  sInput.s = "%CommonProgramFiles%\Microsoft Shared\"
  sOutput.s = StringRegExpReplace(sInput, "%([^%]*?)%", "C:\\WINDOWS\\Some Other Folder")
  Display(sInput, sOutput)
EndProcedure

; The following example demonstrates the back-references
Procedure Test4()
  sInput.s = "The quick brown fox jumps over the lazy dog"
  sOutput.s = StringRegExpReplace(sInput, "([aeiou])", "\1$1${1}2")
  Display(sInput, sOutput)
EndProcedure

Test1()
Test2()
Test3()
Test4()
