﻿
XIncludeFile "module_scroll.pbi"

;
; Module name   : Tree
; Author        : mestnyi
; Last updated  : Aug 7, 2018
; Forum link    : https://www.purebasic.fr/english/viewtopic.php?f=12&t=71123
; 

DeclareModule Tree
  EnableExplicit
  
  #NoButtons = #PB_Tree_NoButtons                     ; 1 Hide the '+' node buttons.
  #NoLines = #PB_Tree_NoLines                         ; 2 Hide the little lines between each nodes.
                                                      ;   #BorderSingle = 4
                                                      ;   #BorderDouble = 8
                                                      ;   #BorderFlat = 16    
  #AlwaysShowSelection = #PB_Tree_AlwaysShowSelection ; 32 Even If the gadget isn't activated, the selection is still visible.
  #BorderLess = 64
  ;   #BorderRaised = 128  
  #CheckBoxes = #PB_Tree_CheckBoxes                   ; 256 Add a checkbox before each Item.
  #ThreeState = #PB_Tree_ThreeState                   ; 65535 The checkboxes can have an "in between" state.
  
  #Selected = #PB_Tree_Selected
  #Checked = #PB_Tree_Checked
  #Expanded = #PB_Tree_Expanded
  #Collapsed = #PB_Tree_Collapsed
  
  #FullRowSelect = #PB_ListIcon_FullRowSelect
  
  
  Structure Coordinate
    y.l[4]
    x.l[4]
    height.l[4]
    width.l[4]
  EndStructure
  
  Structure Tree Extends Coordinate
    hide.b[2]
    disable.b[2]
    
    bSize.l
    fSize.l
    
    flag.l
    
    box.Coordinate
    
    *data
    
    canvas.l
    canvas_window.l
    canvas_gadget.l
    time.l
    from.l
    focus.l
    lostfocus.l
    
    checkboxed.b
    collapsed.b
    childrens.l
    sublevel.l
    Item.l
    adress.l
    Text.s
    
    Font.l
    FontID.i
    
    Image.l
    ImageID.l
    
    Attribute.l
    ImgWidth.l
    ImgHeight.l
    TxtWidth.l
    TxtHeight.l
    
    Scroll.Scroll::Struct
    vScroll.Scroll::Struct
    hScroll.Scroll::Struct
    List Items.Tree()
  EndStructure
  
  Declare.l Gadget(Gadget.l, x.l, y.l, width.l, height.l, flag.l=0)
  Declare AddItem(Gadget.l,Item.l,Text.s,Image.l,sublevel.l=0)
  Declare ClearItems(Gadget.l)
  Declare CountItems(Gadget.l, Item.l=-1)
  Declare RemoveItem(Gadget.l, Item.l)
  Declare GetItemAttribute(Gadget.l, Item.l, Attribute.l)
  Declare GetItemData(Gadget.l, Item.l)
  Declare SetItemData(Gadget.l, Item.l, *data)
  Declare GetItemColor(Gadget.l, Item.l, ColorType.l, Column.l=0)
  Declare SetItemColor(Gadget.l, Item.l, ColorType.l, Color.l, Column.l=0)
  Declare GetItemImage(Gadget.l, Item.l)
  Declare SetItemImage(Gadget.l, Item.l, Image.l)
  Declare GetState(Gadget.l)
  Declare SetState(Gadget.l, Item.l)
  Declare GetItemState(Gadget.l, Item.l)
  Declare SetItemState(Gadget.l, Item.l, State.l)
  Declare.s GetText(Gadget.l)
  Declare SetText(Gadget.l, Text.s)
  Declare.s GetItemText(Gadget.l, Item.l)
  Declare SetItemText(Gadget.l, Item.l, Text.s)
  Declare Free(Gadget.l)
  Declare ReDraw(Gadget.l)
EndDeclareModule

Module Tree
  
  Procedure from(*This.Tree, MouseX=-1, MouseY=-1, focus=0)
    Protected Result.l, lostfocus.l=-1, collapsed.l, sublevel.l, adress.l, coll.l
    
    With *This
      PushListPosition(\Items()) 
      ForEach \Items()
        If \Items()\from = \Items()\Item 
          \Items()\from =- 1
          Result = @\Items()
          Break
        EndIf
      Next
      
      ForEach \Items()
        If \Items()\Item = \Items()\focus
          If Bool(MouseX=-1 And MouseY=-1 And focus=1)
            \Items()\lostfocus = \Items()\focus
          EndIf
          Result = @\Items()
          Break
        EndIf
      Next
      
      If Not Bool(MouseX=-1 And MouseY=-1)
        ForEach \Items()
          If \Items()\hide : Continue : EndIf
          If (MouseY > (\Items()\Y) And MouseY =< ((\Items()\Y+\Items()\Height))) And 
             ((MouseX > \Items()\X) And (MouseX =< (\Items()\X+\Items()\Width)))
            
            If focus
              If (MouseY > (\Items()\box\y[1]) And MouseY =< ((\Items()\box\y[1]+\Items()\box\height[1]))) And 
                 ((MouseX > \Items()\box\x[1]) And (MouseX =< (\Items()\box\x[1]+\Items()\box\width[1])))
                
                \Items()\checkboxed ! 1
              EndIf
              
              If (MouseY > (\Items()\box\y[0]) And MouseY =< ((\Items()\box\y[0]+\Items()\box\height[0]))) And 
                 ((MouseX > \Items()\box\x[0]) And (MouseX =< (\Items()\box\x[0]+\Items()\box\width[0]))) 
                
                sublevel = \Items()\sublevel
                \Items()\collapsed ! 1
                
                PushListPosition(\Items())
                While NextElement(\Items())
                  If sublevel = \Items()\sublevel
                    Break
                  ElseIf sublevel < \Items()\sublevel 
                    If \Items()\adress
                      PushListPosition(\Items())
                      ChangeCurrentElement(\Items(), \Items()\adress)
                      collapsed = \Items()\collapsed
                      If \Items()\hide
                        collapsed = 1
                      EndIf
                      PopListPosition(\Items())
                    EndIf
                    
                    \Items()\hide = collapsed
                  EndIf
                Wend
                PopListPosition(\Items())
              Else
                
                If Result 
                  PushListPosition(\Items()) 
                  ChangeCurrentElement(\Items(), Result)
                  If \Items()\focus = \Items()\Item
                    lostfocus = \Items()\focus 
                    \Items()\lostfocus =- 1
                    \Items()\focus =- 1
                  EndIf
                  PopListPosition(\Items()) 
                  If lostfocus <> \Items()\Item
                    \Items()\lostfocus = lostfocus
                  EndIf
                EndIf
                
                \Items()\focus = \Items()\Item
              EndIf
              
            EndIf
            
            \Items()\from = \Items()\Item
            Result = @\Items()
            Break
          EndIf
        Next
      EndIf
      PopListPosition(\Items())
    EndWith
    
    ProcedureReturn Result
  EndProcedure
  
  Procedure Re(*This.Tree)
    Protected x_content,y_Item,y_point,x_point, height = 16, w=18, level,iY, start,i, back_color=$FFFFFF, content_w
    Protected hide_color=$FEFFFF, box_size = 9,box_size_1 = 13, box_color=$7E7E7E, alpha = 255
    
    With *This\Items()
      y_Item = *This\y[2]
      *This\Scroll\Width=0
      *This\Scroll\Height=0
      
      If ListSize(*This\Items())
        ForEach *This\Items()
          If \hide : Continue : EndIf
          
          \y=y_Item-*This\vScroll\Page\Pos
          \height=height
          \x=*This\x[2]
          \width=*This\width[2]-Scroll::Width(*This\vScroll)
          
          
          y_Item+\height
          *This\Scroll\Height = y_Item
        Next
      EndIf
      
      
    EndWith
    
  EndProcedure
  
  Procedure Draw(*This.Tree)
;     Protected *This.Tree
    Protected x_content,y_point,x_point, height = 16, w=18, level,iY, start,i, back_color=$FFFFFF
    Protected hide_color=$FEFFFF, box_size = 9,box_size_1 = 13, box_color=$7E7E7E, alpha = 255
    
;     If IsGadget(Gadget) : *This.Tree = GetGadgetData(Gadget) : EndIf
    
    If *This And StartDrawing(CanvasOutput(*This\canvas))
      If *This\FontID : DrawingFont(*This\FontID) : EndIf
      If *This\fSize
        DrawingMode(#PB_2DDrawing_Outlined)
        Box(*This\x[1], *This\y[1], *This\width[1], *This\height[1], $ADADAE)
      EndIf
      
      If *This\bSize
        DrawingMode(#PB_2DDrawing_Outlined)
        Box(*This\x[2]-1, *This\y[2]-1, *This\width[2]+2, *This\height[2]+2, $FFFFFF)
      EndIf
      
      DrawingMode(#PB_2DDrawing_Default)
      Box(*This\x[2], *This\y[2], *This\width[2], *This\height[2], back_color)
      
      With *This\Items()
        ;         y_Item = *This\y[2]
        ;         *This\Scroll\Width=0
        ;         *This\Scroll\Height=0
        ClipOutput(*This\x[2], *This\y[2], *This\width[2], *This\height[2])
        
        If ListSize(*This\Items())
          ForEach *This\Items()
            If \hide : Continue : EndIf
            
            ;             \y=y_Item-*This\vScroll\Page\Pos
            ;             \height=height
            ;             \x=*This\x[2]
            ;             \width=*This\width[2]-Scroll::Width(*This\vScroll)
            
            ; Draw selections
            If *This\flag&#FullRowSelect
              If \Item=\from
                DrawingMode(#PB_2DDrawing_Default|#PB_2DDrawing_AlphaBlend)
                Box(\x+1,\y+1,\width-2,\height-2, $FCDFC3&back_color|128<<24)
              EndIf
              
              If \Item=\focus
                If \lostfocus=\focus 
                  If *This\flag&#AlwaysShowSelection
                    DrawingMode(#PB_2DDrawing_Default|#PB_2DDrawing_AlphaBlend)
                    Box(\x+1,\y+1,\width-2,\height-2, $E2E2E2&back_color|128<<24)
                  EndIf
                Else
                  DrawingMode(#PB_2DDrawing_Default|#PB_2DDrawing_AlphaBlend)
                  Box(\x+1,\y+1,\width-2,\height-2, $FFBAA0&back_color|128<<24)
                EndIf
              EndIf
              
              If ((\Item=\focus And \lostfocus<>\focus) Or \Item=\from)
                DrawingMode(#PB_2DDrawing_Outlined|#PB_2DDrawing_AlphaBlend)
                Box(\x,\y,\width,\height, $FFBAA0&back_color|128<<24)
              EndIf
            EndIf
            
            ; Draw boxes
            If Not *This\flag&#NoButtons 
              x_content=(w+\sublevel*w)-*This\hScroll\Page\Pos
              
              If \childrens
                \box\x = x_content-(w+box_size)/2
                \box\y = (\y+height)-(height+box_size)/2
                \box\width = box_size
                \box\height = box_size
                
                DrawingMode(#PB_2DDrawing_Gradient)
                BackColor($FFFFFF) : FrontColor($EEEEEE)
                LinearGradient(\box\x, \box\y, \box\x, (\box\y+\box\height))
                Box(\box\x+1,\box\y+1,\box\width-2,\box\height-2)
                BackColor(#PB_Default) : FrontColor(#PB_Default) ; bug
                
                DrawingMode(#PB_2DDrawing_Outlined|#PB_2DDrawing_AlphaBlend)
                Box(\box\x,\box\y,\box\width,\box\height,box_color&$FFFFFF|alpha<<24)
                
                Line(\box\x+2,\box\y+\box\height/2 ,\box\width/2+1,1, box_color&$FFFFFF|alpha<<24)
                If \collapsed : Line(\box\x+\box\width/2,\box\y+2,1,\box\height/2+1, box_color&$FFFFFF|alpha<<24) : EndIf
              EndIf
            Else
              x_content=(\sublevel*w)-*This\hScroll\Page\Pos
            EndIf
            
            ; Draw plot
            If Not *This\flag&#NoLines
              x_point=x_content-w/2
              y_point=\y+height/2
              
              If x_point>0
                ; Horisontal plot
                If y_point>0 And y_point<OutputHeight()
                  DrawingMode(#PB_2DDrawing_Default|#PB_2DDrawing_AlphaBlend)
                  For i=2 To 6 Step 2
                    Select Point(x_point+i,y_point)
                      Case $F3F3F3, $F7F7F7, $FBFBF
                        Continue
                      Default
                        Line(x_point+i,y_point,1,1, box_color&$FFFFFF|alpha<<24)
                    EndSelect
                  Next
                EndIf
                
                ; Vertical plot
                If \adress 
                  start=Bool(Not \childrens And Not \sublevel)
                  
                  PushListPosition(*This\Items())
                  ChangeCurrentElement(*This\Items(), \adress) 
                  If start : start = (*This\y[2]+\height/2)-*This\vScroll\Page\Pos : Else : start = \y+\height+2 : EndIf
                  
                  DrawingMode(#PB_2DDrawing_Default|#PB_2DDrawing_AlphaBlend)
                  For i=start To y_point Step 2
                    If 0<i And i<OutputHeight() 
                      Select Point(x_point,i)
                        Case $F3F3F3, $F7F7F7, $FBFBFB
                          Continue
                        Default
                          Line(x_point,i,1,1, box_color&$FFFFFF|alpha<<24)
                      EndSelect
                    EndIf
                  Next
                  
                  PopListPosition(*This\Items())
                EndIf
              EndIf
            EndIf
            
            ; Draw box
            If *This\flag&#CheckBoxes
              \box\width[1] = box_size_1
              \box\height[1] = box_size_1
              \box\x[1] = x_content-(w+\box\width[1])/2+w
              \box\y[1] = (\y+height)-(height+\box\height[1])/2
              
              DrawingMode(#PB_2DDrawing_Gradient)
              BackColor($FFFFFF) : FrontColor($EEEEEE)
              LinearGradient(\box\x[1], \box\y[1], \box\x[1], (\box\y[1]+\box\height[1]))
              Box(\box\x[1]+1,\box\y[1]+1,\box\width[1]-2,\box\height[1]-2)
              BackColor(#PB_Default) : FrontColor(#PB_Default) ; bug
              
              DrawingMode(#PB_2DDrawing_Outlined|#PB_2DDrawing_AlphaBlend)
              Box(\box\x[1],\box\y[1],\box\width[1],\box\height[1],box_color&$FFFFFF|alpha<<24)
              
              If \checkboxed
                DrawingMode(#PB_2DDrawing_Outlined|#PB_2DDrawing_AlphaBlend)
                Line(\box\x[1]+2,\box\y[1]+6,3,4,0&$FFFFFF|alpha<<24)
                Line(\box\x[1]+2,\box\y[1]+6+1,4,4,0&$FFFFFF|alpha<<24)
                
                Line(\box\x[1]+5,\box\y[1]+8,6,-6,0&$FFFFFF|alpha<<24)
                Line(\box\x[1]+4,\box\y[1]+8+1,5,-6,0&$FFFFFF|alpha<<24)
              EndIf
              
              x_content+w
            EndIf
            
            If \ImageID
              DrawingMode(#PB_2DDrawing_Transparent|#PB_2DDrawing_AlphaBlend)
              DrawAlphaImage(\ImageID, x_content+3, \y, alpha)
              *This\ImageID = \ImageID
            EndIf
            
            If (*This\ImageID And *This\flag&#NoLines And *This\flag&#NoButtons) Or \ImageID
              x_content+16+3
            EndIf
            
            Protected content_w = TextWidth(\text.s)
            
            If Not *This\flag&#FullRowSelect
              
              If \Item=\focus
                If \lostfocus=\focus 
                  If *This\flag&#AlwaysShowSelection
                    DrawingMode(#PB_2DDrawing_Default|#PB_2DDrawing_AlphaBlend)
                    Box(x_content+1+3,\y+1,content_w-2,\height-2, $E2E2E2&back_color|128<<24)
                  EndIf
                Else
                  DrawingMode(#PB_2DDrawing_Default|#PB_2DDrawing_AlphaBlend)
                  Box(x_content+1+3,\y+1,content_w-2,\height-2, $FFBAA0&back_color|128<<24)
                EndIf
              EndIf
              
              If (\Item=\focus And \lostfocus<>\focus)
                DrawingMode(#PB_2DDrawing_Outlined|#PB_2DDrawing_AlphaBlend)
                Box(x_content+3,\y,content_w,\height, $FFBAA0&back_color|128<<24)
              EndIf
            EndIf
            
            ClipOutput(*This\x[2], *This\y[2], \width, *This\height[2])
            DrawingMode(#PB_2DDrawing_Transparent|#PB_2DDrawing_AlphaBlend)
            DrawText(x_content+3, \y+(height-TextHeight("A"))/2, \text.s, $000000&$FFFFFF|alpha<<24)
            
            If *This\Scroll\Width < (x_content+*This\hScroll\Page\Pos)+content_w+6
              *This\Scroll\Width = (x_content+*This\hScroll\Page\Pos)+content_w+6
            EndIf
          Next
        EndIf
        
        If *This\vScroll\Page\Length And *This\vScroll\Max<>*This\Scroll\Height
          If Scroll::SetAttribute(*This\vScroll, #PB_ScrollBar_Maximum, *This\Scroll\Height)
            Scroll::Resizes(*This\vScroll, *This\hScroll, #PB_Ignore, #PB_Ignore, #PB_Ignore, #PB_Ignore)
          EndIf
        EndIf
        
        If *This\hScroll\Page\Length And *This\hScroll\Max<>*This\Scroll\Width
          If Scroll::SetAttribute(*This\hScroll, #PB_ScrollBar_Maximum, *This\Scroll\Width)
            Scroll::Resizes(*This\vScroll, *This\hScroll, #PB_Ignore, #PB_Ignore, #PB_Ignore, #PB_Ignore)
          EndIf
        EndIf
        
        UnclipOutput()
        
        Scroll::Draw(*This\vScroll)
        Scroll::Draw(*This\hScroll)
        
        StopDrawing()
      EndWith
    EndIf
  EndProcedure
  
  Procedure ReDraw(Gadget.l)
    Protected *This.Tree
    If IsGadget(Gadget) : *This.Tree = GetGadgetData(Gadget) : EndIf
    If *This
      Re(*This)
      Draw(*This)
    EndIf
  EndProcedure
  
  Procedure AddItem(Gadget.l,Item.l,Text.s,Image.l,sublevel.l=0)
    Static adress.l
    Protected *This.Tree, Childrens.l, hide.b
    If IsGadget(Gadget) : *This.Tree = GetGadgetData(Gadget) : EndIf
    
    If Not *This
      ProcedureReturn -1
    EndIf
    
    With *This\Items()
      ;{ Генерируем идентификатор
      If Item =- 1 Or Item > ListSize(*This\Items()) - 1
        LastElement(*This\Items())
        AddElement(*This\Items()) 
        Item = ListIndex(*This\Items())
      Else
        SelectElement(*This\Items(), Item)
        If \sublevel>sublevel
          sublevel=\sublevel 
        EndIf
        InsertElement(*This\Items())
        
        PushListPosition(*This\Items())
        While NextElement(*This\Items())
          \Item = ListIndex(*This\Items())
        Wend
        PopListPosition(*This\Items())
      EndIf
      ;}
      
      If subLevel
        If sublevel>ListIndex(*This\Items())
          sublevel=ListIndex(*This\Items())
        EndIf
        PushListPosition(*This\Items()) 
        While PreviousElement(*This\Items()) 
          If subLevel = *This\Items()\subLevel
            adress = *This\Items()\adress
            Break
          ElseIf subLevel > *This\Items()\subLevel
            adress = @*This\Items()
            Break
          EndIf
        Wend 
        If adress
          ChangeCurrentElement(*This\Items(), adress)
          If subLevel > *This\Items()\subLevel
            sublevel=*This\Items()\sublevel + 1
            *This\Items()\childrens + 1
            *This\Items()\collapsed = 1
            hide = 1
          EndIf
        EndIf
        
        PopListPosition(*This\Items()) 
        \hide = hide
      Else
        If Not Item 
          adress = FirstElement(*This\Items()) 
        EndIf
      EndIf
      
      \from =- 1
      \focus =- 1
      \lostfocus =- 1
      \time = ElapsedMilliseconds()
      \Item = Item
      \adress = adress
      \Text.s = Text.s ;+" ("+Str(iadress)+"-"+Str(SubLevel)+")" 
      \sublevel = sublevel
      
      If IsImage(Image)
        Select *This\Attribute
          Case #PB_ListIcon_LargeIcon
            \ImgWidth = 32
            \ImgHeight = 32
            ResizeImage(Image, \ImgWidth,\ImgHeight)
            
          Case #PB_ListIcon_SmallIcon
            \ImgWidth = 16
            \ImgHeight = 16
            ResizeImage(Image, \ImgWidth,\ImgHeight)
        EndSelect   
        
        \Image = Image
        \ImageID = ImageID(Image)
      EndIf
      
;       Re(*This)
      
      If *This\Scroll\Height=<*This\height
      ;  Draw(*This)
      EndIf
    EndWith
    
    ProcedureReturn Item
  EndProcedure
  
  Procedure ClearItems(Gadget.l)
    Protected Result.l, *This.Tree
    If IsGadget(Gadget) : *This.Tree = GetGadgetData(Gadget) : EndIf
    
    If *This
      With *This
        Result = ClearList(\Items())
        If StartDrawing(CanvasOutput(Gadget))
          Box(0,0,OutputWidth(),OutputHeight(), $FFFFFF)
          StopDrawing()
        EndIf
      EndWith
    EndIf
    
    ProcedureReturn Result
  EndProcedure
  
  Procedure CountItems(Gadget.l, Item.l=-1)
    Protected Result.l, *This.Tree, sublevel.l
    If IsGadget(Gadget) : *This.Tree = GetGadgetData(Gadget) : EndIf
    
    If *This
      With *This
        If Item.l=-1
          Result = ListSize(\Items())
        Else
          PushListPosition(\Items()) 
          ForEach \Items()
            If \Items()\Item = Item 
              ; Result = \Items()\childrens 
              sublevel = \Items()\sublevel
              PushListPosition(\Items())
              While NextElement(\Items())
                If sublevel = \Items()\sublevel
                  Break
                ElseIf sublevel < \Items()\sublevel 
                  Result+1
                EndIf
              Wend
              PopListPosition(\Items())
              Break
            EndIf
          Next
          PopListPosition(\Items())
        EndIf
      EndWith
    EndIf
    
    ProcedureReturn Result
  EndProcedure
  
  Procedure RemoveItem(Gadget.l, Item.l)
    Protected Result.l, *This.Tree, sublevel.l
    If IsGadget(Gadget) : *This.Tree = GetGadgetData(Gadget) : EndIf
    
    If *This
      With *This
        PushListPosition(\Items()) 
        ForEach \Items()
          If \Items()\Item = Item 
            sublevel = \Items()\sublevel
            PushListPosition(\Items())
            While NextElement(\Items())
              If sublevel = \Items()\sublevel
                Break
              ElseIf sublevel < \Items()\sublevel 
                Result = DeleteElement(\Items()) 
              EndIf
            Wend
            PopListPosition(\Items())
            Result = DeleteElement(\Items()) 
            Break
          EndIf
        Next
        PopListPosition(\Items())
        
        ReDraw(Gadget)
      EndWith
    EndIf
    
    ProcedureReturn Result
  EndProcedure
  
  Procedure GetItemAttribute(Gadget.l, Item.l, Attribute.l)
    Protected Result.l, *This.Tree
    If IsGadget(Gadget) : *This.Tree = GetGadgetData(Gadget) : EndIf
    
    If *This
      With *This
        PushListPosition(\Items()) 
        ForEach \Items()
          If \Items()\Item = Item 
            Select Attribute
              Case #PB_Tree_SubLevel
                Result = \Items()\sublevel
                
            EndSelect
            Break
          EndIf
        Next
        PopListPosition(\Items())
      EndWith
    EndIf
    
  EndProcedure
  
  Procedure GetItemData(Gadget.l, Item.l)
    Protected Result.l, *This.Tree
    If IsGadget(Gadget) : *This.Tree = GetGadgetData(Gadget) : EndIf
    
    If *This
      With *This
        PushListPosition(\Items()) 
        ForEach \Items()
          If \Items()\Item = Item 
            Result = \Items()\data
            Break
          EndIf
        Next
        PopListPosition(\Items())
      EndWith
    EndIf
    
    ProcedureReturn Result
  EndProcedure
  
  Procedure SetItemData(Gadget.l, Item.l, *data)
    Protected Result.l, *This.Tree
    If IsGadget(Gadget) : *This.Tree = GetGadgetData(Gadget) : EndIf
    
    If *This
      With *This
        PushListPosition(\Items()) 
        ForEach \Items()
          If \Items()\Item = Item 
            \Items()\data = *data
            Break
          EndIf
        Next
        PopListPosition(\Items())
      EndWith
    EndIf
    
    ProcedureReturn Result
  EndProcedure
  
  Procedure GetItemColor(Gadget.l, Item.l, ColorType.l, Column.l=0)
    Protected Result.l, *This.Tree
    If IsGadget(Gadget) : *This.Tree = GetGadgetData(Gadget) : EndIf
    
    If *This
      With *This
        PushListPosition(\Items()) 
        ForEach \Items()
          If \Items()\Item = Item 
            
            Break
          EndIf
        Next
        PopListPosition(\Items())
      EndWith
    EndIf
    
    ProcedureReturn Result
  EndProcedure
  
  Procedure SetItemColor(Gadget.l, Item.l, ColorType.l, Color.l, Column.l=0)
    Protected Result.l, *This.Tree
    If IsGadget(Gadget) : *This.Tree = GetGadgetData(Gadget) : EndIf
    
    If *This
      With *This
        PushListPosition(\Items()) 
        ForEach \Items()
          If \Items()\Item = Item 
            
            Break
          EndIf
        Next
        PopListPosition(\Items())
      EndWith
    EndIf
    
    ProcedureReturn Result
  EndProcedure
  
  Procedure GetItemImage(Gadget.l, Item.l)
    Protected Result.l, *This.Tree
    If IsGadget(Gadget) : *This.Tree = GetGadgetData(Gadget) : EndIf
    
    If *This
      With *This
        PushListPosition(\Items()) 
        ForEach \Items()
          If \Items()\Item = Item 
            Result = \Items()\Image
            Break
          EndIf
        Next
        PopListPosition(\Items())
      EndWith
    EndIf
    
    ProcedureReturn Result
  EndProcedure
  
  Procedure SetItemImage(Gadget.l, Item.l, image.l)
    Protected Result.l, *This.Tree
    If IsGadget(Gadget) : *This.Tree = GetGadgetData(Gadget) : EndIf
    
    If *This
      With *This
        PushListPosition(\Items()) 
        ForEach \Items()
          If \Items()\Item = Item And IsImage(image)
            \Items()\Image = image 
            \Items()\ImageID = ImageID(image)
            Break
          EndIf
        Next
        PopListPosition(\Items())
      EndWith
    EndIf
    
    ProcedureReturn Result
  EndProcedure
  
  Procedure SetState(Gadget.l, Item.l)
    Protected Result.l, *This.Tree, lostfocus.l=-1, collapsed.l, sublevel.l, adress.l, coll.l
    If IsGadget(Gadget) : *This.Tree = GetGadgetData(Gadget) : EndIf
    
    If *This
      With *This
        PushListPosition(\Items()) 
        ForEach \Items()
          If \Items()\from = \Items()\Item 
            \Items()\from =- 1
            Result = @\Items()
            Break
          EndIf
        Next
        
        ForEach \Items()
          If \Items()\Item = \Items()\focus
            \Items()\lostfocus = \Items()\focus
            If Item =- 1 : \Items()\focus =- 1 : EndIf
            Result = @\Items()
            Break
          EndIf
        Next
        
        If Item <>- 1
          ForEach \Items()
            If \Items()\hide : Continue : EndIf
            If \Items()\Item = Item
              
              If Result 
                PushListPosition(\Items()) 
                ChangeCurrentElement(\Items(), Result)
                If \Items()\focus = \Items()\Item
                  lostfocus = \Items()\focus 
                  \Items()\lostfocus =- 1
                  \Items()\focus =- 1
                EndIf
                PopListPosition(\Items()) 
                If lostfocus <> \Items()\Item
                  \Items()\lostfocus = lostfocus
                EndIf
              EndIf
              
              \Items()\focus = \Items()\Item
              \Items()\from = \Items()\Item
              
              If GetActiveGadget()<>Gadget
                \Items()\lostfocus = \Items()\focus
                \Items()\from =- 1
              EndIf
              
              Result = @\Items()
              Break
              
            EndIf
          Next
        EndIf
        PopListPosition(\Items())
        
        ReDraw(Gadget)
      EndWith
    EndIf
    
    ProcedureReturn Result
  EndProcedure
  
  Procedure GetState(Gadget.l)
    Protected Result.l, *This.Tree 
    If IsGadget(Gadget) : *This.Tree = GetGadgetData(Gadget) : EndIf
    
    If *This 
      With *This
        PushListPosition(\Items()) 
        ForEach \Items()
          If \Items()\hide : Continue : EndIf
          If \Items()\Item = \Items()\focus
            Result = \Items()\Item
            Break
          EndIf
        Next
        PopListPosition(\Items())
      EndWith
    EndIf
    
    ProcedureReturn Result
  EndProcedure
  
  Procedure SetItemState(Gadget.l, Item.l, State.l)
    Protected Result.l, *This.Tree, lostfocus.l=-1, collapsed.l, sublevel.l, adress.l, coll.l
    If IsGadget(Gadget) : *This.Tree = GetGadgetData(Gadget) : EndIf
    
    If *This
      With *This
        PushListPosition(\Items()) 
        ForEach \Items()
          If \Items()\hide : Continue : EndIf
          If \Items()\Item = Item
            If State&#Selected
              \Items()\focus = \Items()\Item
              
              If GetActiveGadget()<>Gadget
                \Items()\lostfocus = \Items()\focus
                \Items()\from =- 1
              EndIf
              
            EndIf
            If State&#Checked
              \Items()\checkboxed = 1
            EndIf
            If State&#Collapsed Or State&#Expanded
              \Items()\collapsed = Bool(State&#Collapsed)
              
              sublevel = \Items()\sublevel
              
              PushListPosition(\Items())
              While NextElement(\Items())
                If sublevel = \Items()\sublevel
                  Break
                ElseIf sublevel < \Items()\sublevel 
                  If State&#Collapsed
                    \Items()\hide = 1
                  ElseIf State&#Expanded
                    \Items()\hide = 0
                  EndIf
                EndIf
              Wend
            EndIf
            Break
          EndIf
        Next
        PopListPosition(\Items())
        
        ReDraw(Gadget)
      EndWith
    EndIf
    
    ProcedureReturn Result
  EndProcedure
  
  Procedure GetItemState(Gadget.l, Item.l)
    Protected Result.l, *This.Tree, lostfocus.l=-1, collapsed.l, sublevel.l, adress.l, coll.l
    If IsGadget(Gadget) : *This.Tree = GetGadgetData(Gadget) : EndIf
    
    If *This
      With *This
        PushListPosition(\Items()) 
        ForEach \Items()
          If \Items()\hide : Continue : EndIf
          If \Items()\Item = Item
            Result = #Selected
            If \Items()\collapsed
              Result | #Collapsed
            Else
              Result | #Expanded
            EndIf
            If \Items()\checkboxed
              Result | #Checked
            EndIf
            Break
          EndIf
        Next
        PopListPosition(\Items())
      EndWith
    EndIf
    
    ProcedureReturn Result
  EndProcedure
  
  Procedure.s GetText(Gadget.l)
    Protected Result.s, *This.Tree
    If IsGadget(Gadget) : *This.Tree = GetGadgetData(Gadget) : EndIf
    
    If *This
      With *This
        PushListPosition(\Items()) 
        ForEach \Items()
          If \Items()\hide : Continue : EndIf
          If \Items()\Item = \Items()\focus
            Result = \Items()\Text
            Break
          EndIf
        Next
        PopListPosition(\Items())
      EndWith
    EndIf  
    
    ProcedureReturn Result
  EndProcedure
  
  Procedure SetText(Gadget.l, Text.s)
    Protected Result.l, *This.Tree
    If IsGadget(Gadget) : *This.Tree = GetGadgetData(Gadget) : EndIf
    
    If *This
      With *This
        PushListPosition(\Items()) 
        ForEach \Items()
          If \Items()\hide : Continue : EndIf
          If \Items()\Item = \Items()\focus
            \Items()\Text = Text
            Break
          EndIf
        Next
        PopListPosition(\Items())
      EndWith
    EndIf
    
    ProcedureReturn Result
  EndProcedure
  
  Procedure.s GetItemText(Gadget.l, Item.l)
    Protected Result.s, *This.Tree
    If IsGadget(Gadget) : *This.Tree = GetGadgetData(Gadget) : EndIf
    
    If *This
      With *This
        PushListPosition(\Items()) 
        ForEach \Items()
          If \Items()\hide : Continue : EndIf
          If \Items()\Item = Item
            Result = \Items()\Text
            Break
          EndIf
        Next
        PopListPosition(\Items())
      EndWith
    EndIf
    
    ProcedureReturn Result
  EndProcedure
  
  Procedure SetItemText(Gadget.l, Item.l, Text.s)
    Protected Result.l, *This.Tree
    If IsGadget(Gadget) : *This.Tree = GetGadgetData(Gadget) : EndIf
    
    If *This
      With *This
        PushListPosition(\Items()) 
        ForEach \Items()
          If \Items()\hide : Continue : EndIf
          If \Items()\Item = Item
            \Items()\Text = Text
            Break
          EndIf
        Next
        PopListPosition(\Items())
      EndWith
    EndIf
    
    ProcedureReturn Result
  EndProcedure
  
  Procedure CallBack()
    Protected Repaint.l
    Protected Event = EventType()
    Protected Window = EventWindow()
    Protected Canvas = EventGadget()
    Protected MouseX = GetGadgetAttribute(Canvas, #PB_Canvas_MouseX)
    Protected MouseY = GetGadgetAttribute(Canvas, #PB_Canvas_MouseY)
    Protected Buttons = GetGadgetAttribute(Canvas, #PB_Canvas_Buttons)
    Protected WheelDelta = GetGadgetAttribute(Canvas, #PB_Canvas_WheelDelta)
    Protected Width = GadgetWidth(Canvas)
    Protected Height = GadgetHeight(Canvas)
    Protected ScrollX, ScrollY, ScrollWidth, ScrollHeight
    
    Protected *This.Tree = GetGadgetData(Canvas)
    
    With *This
      Repaint = Scroll::CallBack(*This\vScroll, Event, MouseX, MouseY, WheelDelta)
      If Repaint 
        ReDraw(Canvas)
        PostEvent(#PB_Event_Gadget, Window, Canvas, #PB_EventType_Change)
      EndIf
      
      Repaint = Scroll::CallBack(*This\hScroll, Event, MouseX, MouseY, WheelDelta)
      If Repaint 
        ReDraw(Canvas)
        PostEvent(#PB_Event_Gadget, Window, Canvas, #PB_EventType_Change)
      EndIf
      
      If Not (*This\vScroll\Buttons Or *This\hScroll\Buttons)
        Select Event
          Case #PB_EventType_MouseWheel
            Select -WheelDelta
              Case-1 : Repaint = Scroll::SetState(*This\vScroll, *This\vScroll\Page\Pos - (*This\vScroll\Max-*This\vScroll\Min)/30)
              Case 1 : Repaint = Scroll::SetState(*This\vScroll, *This\vScroll\Page\Pos + (*This\vScroll\Max-*This\vScroll\Min)/30)
            EndSelect
            
          Case #PB_EventType_LeftButtonDown
            Repaint = from(*This, MouseX, MouseY, 1)
            
          Case #PB_EventType_MouseMove
            Repaint = from(*This, MouseX, MouseY)
            
          Case #PB_EventType_MouseLeave
            Repaint = from(*This,-1,-1, 0)
            
          Case #PB_EventType_LostFocus
            Repaint = from(*This,-1,-1, 1)
            
          Case #PB_EventType_Focus
            PushListPosition(\Items()) 
            ForEach \Items()
              If \Items()\Item = \Items()\focus And \Items()\focus = \Items()\lostfocus 
                \Items()\lostfocus =- 1
                Repaint = 1
                Break
              EndIf
            Next
            PopListPosition(\Items()) 
            
          Case #PB_EventType_Resize : ResizeGadget(\Canvas, #PB_Ignore, #PB_Ignore, #PB_Ignore, #PB_Ignore) ; Bug (562)
            \Width = GadgetWidth(\Canvas)
            \Height = GadgetHeight(\Canvas)
            
            ; Inner coordinate
            \X[2]=\bSize
            \Y[2]=\bSize
            \Width[2] = \Width-\bSize*2
            \Height[2] = \Height-\bSize*2
            
            ; Frame coordinae
            \X[1]=\X[2]-\fSize
            \Y[1]=\Y[2]-\fSize
            \Width[1] = \Width[2]+\fSize*2
            \Height[1] = \Height[2]+\fSize*2
            
;             Debug 77777
            Scroll::Resizes(*This\vScroll, *This\hScroll, *This\X[2],*This\Y[2], *This\Width[2],*This\Height[2])
            Repaint = 1
        EndSelect
      Else
        Repaint = from(*This,-1,-1, 0)
      EndIf
    EndWith 
    
    If Repaint 
      Re(*This)
      ReDraw(Canvas)
    EndIf
  EndProcedure
  
  Procedure.l Gadget(Gadget.l, x.l, y.l, width.l, height.l, flag.l=0)
    Protected g = CanvasGadget(Gadget, x, y, width, height, #PB_Canvas_Keyboard) : If Gadget=-1 : Gadget = g : EndIf
    
    Protected *This.Tree=AllocateStructure(Tree)
    If *This
      With *This
        If Not flag&#BorderLess
          \bSize = 2
          \fSize = 2
        EndIf
        
        \canvas_window = GetActiveWindow()
        
        \Attribute=-1
        \FontID = GetGadgetFont(#PB_Default) ; FontID(LoadFont(#PB_Any,"Tahoma",8)) ; 
        \canvas = Gadget
        \flag = flag
        
        \Width = width
        \Height = height
        
        ; Inner coordinate
        \X[2]=\bSize
        \Y[2]=\bSize
        \Width[2] = \Width-\bSize*2
        \Height[2] = \Height-\bSize*2
        
        ; Frame coordinae
        \X[1]=\X[2]-\fSize+1
        \Y[1]=\Y[2]-\fSize+1
        \Width[1] = \Width[2]+\fSize*2-2
        \Height[1] = \Height[2]+\fSize*2-2
        
        ;
        Scroll::Gadget(*This\vScroll, #PB_Ignore, #PB_Ignore, 17, #PB_Ignore, 0,0,0, #PB_ScrollBar_Vertical)
        Scroll::Gadget(*This\hScroll, #PB_Ignore, #PB_Ignore, #PB_Ignore, 17, 0,0,0, 0)
        PostEvent(#PB_Event_Gadget, \canvas_window, Gadget, #PB_EventType_Resize)
; ;         AddWindowTimer(\canvas_window, 12, 5000)
; ;         BindEvent(#PB_Event_Timer, @bind(), \canvas_window, Gadget)
        
        ;         ; Set style windows 8
        ;         *This\vScroll\DrawingMode = #PB_2DDrawing_Default
        ;         Scroll::SetColor(*This\vScroll, #PB_Gadget_BackColor, *This\vScroll\Color\Back, 1)
        ;         Scroll::SetColor(*This\vScroll, #PB_Gadget_BackColor, *This\vScroll\Color\Back, 2)
        ;         
        ;         *This\hScroll\DrawingMode = #PB_2DDrawing_Default
        ;         Scroll::SetColor(*This\hScroll, #PB_Gadget_BackColor, *This\hScroll\Color\Back, 1)
        ;         Scroll::SetColor(*This\hScroll, #PB_Gadget_BackColor, *This\hScroll\Color\Back, 2)
        
        SetGadgetData(Gadget, *This)
        BindGadgetEvent(Gadget, @CallBack())
      EndWith
    EndIf
    
    ProcedureReturn g
  EndProcedure
  
  Procedure Free(Gadget.l)
    Protected Result, *This.Tree
    If IsGadget(Gadget) : *This.Tree = GetGadgetData(Gadget) : EndIf
    
    If *This
      FreeStructure(*This)
      ; SetGadgetData(Gadget, #Null)
      UnbindGadgetEvent(Gadget, @CallBack())
      ; SetGadgetColor(Gadget, #PB_Gadget_BackColor, $FFFFFF)
      If StartDrawing(CanvasOutput(Gadget))
        Box(0,0,OutputWidth(),OutputHeight(), $FFFFFF)
        StopDrawing()
      EndIf
    EndIf
    
    ProcedureReturn Result
  EndProcedure
  
EndModule

;- 
;- example
;-
CompilerIf #PB_Compiler_IsMainFile
  UseModule Tree
  
  Procedure Events()
    If EventType() = #PB_EventType_LeftClick
      If GadgetType(EventGadget()) = #PB_GadgetType_Tree
        Debug GetGadgetText(EventGadget())
        Debug GetGadgetState(EventGadget())
        Debug GetGadgetItemState(EventGadget(), GetGadgetState(EventGadget()))
      Else
        Debug Tree::GetText(EventGadget())
        Debug Tree::GetState(EventGadget())
        Debug Tree::GetItemState(EventGadget(), Tree::GetState(EventGadget()))
      EndIf
    EndIf
  EndProcedure
  
  If LoadImage(0, #PB_Compiler_Home + "examples/sources/Data/File.bmp") ; Измените путь/имя файла на собственное изображение 32x32 пикселя
  EndIf
  
  If OpenWindow(0, 0, 0, 1110, 450, "TreeGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
    Define i,a,g = 1
    TreeGadget(g, 10, 10, 210, 210, #PB_Tree_AlwaysShowSelection|#PB_Tree_CheckBoxes)                                         
    ; 1_example
    AddGadgetItem(g, 0, "Normal Item "+Str(a), 0, 0) 
    AddGadgetItem(g, -1, "Node "+Str(a), ImageID(0), 0)      
    AddGadgetItem(g, -1, "Sub-Item 1", 0, 1)         
    AddGadgetItem(g, -1, "Sub-Item 2", 0, 11)
    AddGadgetItem(g, -1, "Sub-Item 3", 0, 1)
    AddGadgetItem(g, -1, "Sub-Item 4", 0, 1)         
    AddGadgetItem(g, -1, "Sub-Item 5", 0, 11)
    AddGadgetItem(g, -1, "Sub-Item 6", 0, 1)
    AddGadgetItem(g, -1, "File "+Str(a), 0, 0) 
    For i=0 To CountGadgetItems(g) : SetGadgetItemState(g, i, #PB_Tree_Expanded) : Next
    
    ; RemoveGadgetItem(g,1)
    SetGadgetItemState(g, 1, #PB_Tree_Selected|#PB_Tree_Collapsed|#PB_Tree_Checked)
    BindGadgetEvent(g, @Events())
    
    ;SetActiveGadget(g)
    ;SetGadgetState(g, 1)
    ;     Debug "g "+ GetGadgetText(g)
    
    g = 2
    TreeGadget(g, 230, 10, 210, 210, #PB_Tree_AlwaysShowSelection)                                         
    ; 3_example
    AddGadgetItem(g, 0, "i_0", 0 )
    AddGadgetItem(g, 1, "i_1_1", ImageID(0), 1) 
    AddGadgetItem(g, 4, "i_1_1_1", 0, 2) 
    AddGadgetItem(g, 5, "i_1_1_2", 0, 2) 
    AddGadgetItem(g, 6, "i_1_1_2_1", 0, 3) 
    AddGadgetItem(g, 8, "i_1_1_2_1_1", 0, 4) 
    AddGadgetItem(g, 7, "i_1_1_2_2", 0, 3) 
    AddGadgetItem(g, 2, "i_1_2", 0, 1) 
    AddGadgetItem(g, 3, "i_1_3", 0, 1) 
    AddGadgetItem(g, 9, "i_2" )
    AddGadgetItem(g, 10, "i_3", 0 )
    
    AddGadgetItem(g, 6, "i_1_1_2_1", 0, 3) 
    AddGadgetItem(g, 8, "i_1_1_2_1_1", 0, 4) 
    AddGadgetItem(g, 7, "i_1_1_2_2", 0, 3) 
    AddGadgetItem(g, 2, "i_1_2", 0, 1) 
    AddGadgetItem(g, 3, "i_1_3", 0, 1) 
    AddGadgetItem(g, 9, "i_2" )
    AddGadgetItem(g, 10, "i_3", 0 )
    For i=0 To CountGadgetItems(g) : SetGadgetItemState(g, i, #PB_Tree_Expanded) : Next
    
    ; ClearGadgetItems(g)
    
    g = 3
    TreeGadget(g, 450, 10, 210, 210, #PB_Tree_AlwaysShowSelection|#PB_Tree_NoLines|#PB_Tree_NoButtons)                                         
    ;   ;  2_example
    ;   AddGadgetItem(g, 0, "Normal Item "+Str(a), 0, 0) 
    ;   AddGadgetItem(g, 1, "Node "+Str(a), 0, 1)       
    ;   AddGadgetItem(g, 4, "Sub-Item 1", 0, 2)          
    ;   AddGadgetItem(g, 2, "Sub-Item 2", 0, 1)
    ;   AddGadgetItem(g, 3, "Sub-Item 3", 0, 1)
    
    ;  2_example
    AddGadgetItem(g, 0, "Tree_0 (NoLines | NoButtons | NoSublavel)",ImageID(0)) 
    For i=1 To 20
      If i=5
        AddGadgetItem(g, -1, "Tree_"+Str(i), 0) 
      Else
        AddGadgetItem(g, -1, "Tree_"+Str(i), ImageID(0)) 
      EndIf
    Next
    For i=0 To CountGadgetItems(g) : SetGadgetItemState(g, i, #PB_Tree_Expanded) : Next
    
    g = 4
    TreeGadget(g, 670, 10, 210, 210, #PB_Tree_AlwaysShowSelection|#PB_Tree_NoLines)                                         
    ; 4_example
    AddGadgetItem(g, 0, "Tree_0 (NoLines|AlwaysShowSelection)", 0 )
    AddGadgetItem(g, 1, "Tree_1", 0, 1) 
    AddGadgetItem(g, 2, "Tree_2_2", 0, 2) 
    AddGadgetItem(g, 2, "Tree_2_1", 0, 1) 
    AddGadgetItem(g, 3, "Tree_3_1", 0, 1) 
    AddGadgetItem(g, 3, "Tree_3_2", 0, 2) 
    For i=0 To CountGadgetItems(g) : SetGadgetItemState(g, i, #PB_Tree_Expanded) : Next
    
    g = 5
    TreeGadget(g, 890, 10, 103, 210, #PB_Tree_AlwaysShowSelection|#PB_Tree_NoButtons)                                         
    ; 5_example
    AddGadgetItem(g, 0, "Tree_0 (NoButtons)", 0 )
    AddGadgetItem(g, 1, "Tree_1", 0, 1) 
    AddGadgetItem(g, 2, "Tree_2_1", 0, 1) 
    AddGadgetItem(g, 2, "Tree_2_2", 0, 2) 
    For i=0 To CountGadgetItems(g) : SetGadgetItemState(g, i, #PB_Tree_Expanded) : Next
    
    g = 6
    TreeGadget(g, 890+106, 10, 103, 210, #PB_Tree_AlwaysShowSelection)                                         
    ;  6_example
    AddGadgetItem(g, 0, "Tree_1", 0, 1) 
    AddGadgetItem(g, 0, "Tree_2_1", 0, 2) 
    AddGadgetItem(g, 0, "Tree_2_2", 0, 3) 
    
    
    g = 10
    Gadget(g, 10, 230, 210, 210, #PB_Tree_AlwaysShowSelection|#PB_Tree_CheckBoxes)                                         
    ; 1_example
    AddItem (g, 0, "Normal Item "+Str(a), -1, 0)                                   
    AddItem (g, -1, "Node "+Str(a), 0, 0)                                         
    AddItem (g, -1, "Sub-Item 1", -1, 1)                                           
    AddItem (g, -1, "Sub-Item 2", -1, 11)
    AddItem (g, -1, "Sub-Item 3", -1, 1)
    AddItem (g, -1, "Sub-Item 4", -1, 1)                                           
    AddItem (g, -1, "Sub-Item 5", -1, 11)
    AddItem (g, -1, "Sub-Item 6", -1, 1)
    AddItem (g, -1, "File "+Str(a), -1, 0)  
    For i=0 To CountItems(g) : SetItemState(g, i, #PB_Tree_Expanded) : Next
    
    ; RemoveItem(g,1)
    Tree::SetItemState(g, 1, #PB_Tree_Selected|#PB_Tree_Collapsed|#PB_Tree_Checked)
    BindGadgetEvent(g, @Events())
    ;Tree::SetState(g, 1)
    ;Tree::SetState(g, -1)
    ;     Debug "c "+Tree::GetText(g)
    
    g = 11
    Gadget(g, 230, 230, 210, 210, #PB_Tree_AlwaysShowSelection)                                         
    ;  3_example
    AddItem(g, 0, "i_0", -1 )
    AddItem(g, 1, "i_1_1", 0, 1) 
    AddItem(g, 4, "i_1_1_1", -1, 2) 
    AddItem(g, 5, "i_1_1_2", -1, 2) 
    AddItem(g, 6, "i_1_1_2_1", -1, 3) 
    AddItem(g, 8, "i_1_1_2_1_1", -1, 4) 
    AddItem(g, 7, "i_1_1_2_2", -1, 3) 
    AddItem(g, 2, "i_1_2", -1, 1) 
    AddItem(g, 3, "i_1_3", -1, 1) 
    AddItem(g, 9, "i_2",-1 )
    AddItem(g, 10, "i_3", -1 )
    
    AddItem(g, 6, "i_1_1_2_1", -1, 3) 
    AddItem(g, 8, "i_1_1_2_1_1", -1, 4) 
    AddItem(g, 7, "i_1_1_2_2", -1, 3) 
    AddItem(g, 2, "i_1_2", -1, 1) 
    AddItem(g, 3, "i_1_3", -1, 1) 
    AddItem(g, 9, "i_2",-1 )
    AddItem(g, 10, "i_3", -1 )
    For i=0 To CountItems(g) : SetItemState(g, i, #PB_Tree_Expanded) : Next
    
    ; ClearItems(g)
    
    g = 12
    Gadget(g, 450, 230, 210, 210, #PB_Tree_AlwaysShowSelection|#PB_Tree_NoLines|#PB_Tree_NoButtons|#FullRowSelect)                                        
    ;   ;  2_example
    ;   AddItem (g, 0, "Normal Item "+Str(a), -1, 0)                                    
    ;   AddItem (g, 1, "Node "+Str(a), -1, 1)                                           
    ;   AddItem (g, 4, "Sub-Item 1", -1, 2)                                            
    ;   AddItem (g, 2, "Sub-Item 2", -1, 1)
    ;   AddItem (g, 3, "Sub-Item 3", -1, 1)
    
    ;  2_example
    AddItem (g, 0, "Tree_0 (NoLines | NoButtons | NoSublavel)", 0)                                    
    For i=1 To 20
      If i=5
        AddItem(g, -1, "Tree_"+Str(i), -1) 
      Else
        AddItem(g, -1, "Tree_"+Str(i), 0) 
      EndIf
    Next
    For i=0 To CountItems(g) : SetItemState(g, i, #PB_Tree_Expanded) : Next
    
    g = 13
    Gadget(g, 670, 230, 210, 210, #PB_Tree_AlwaysShowSelection|#PB_Tree_NoLines)                                         
    ;  4_example
    AddItem(g, 0, "Tree_0 (NoLines|AlwaysShowSelection)", -1 )
    AddItem(g, 1, "Tree_1", -1, 1) 
    AddItem(g, 2, "Tree_2_2", -1, 2) 
    AddItem(g, 2, "Tree_2_1", -1, 1) 
    AddItem(g, 3, "Tree_3_1", -1, 1) 
    AddItem(g, 3, "Tree_3_2", -1, 2) 
    For i=0 To CountItems(g) : SetItemState(g, i, #PB_Tree_Expanded) : Next
    
    
    g = 14
    Gadget(g, 890, 230, 103, 210, #PB_Tree_AlwaysShowSelection|#PB_Tree_NoButtons)                                         
    ;  5_example
    AddItem(g, 0, "Tree_0 (NoButtons)", -1 )
    AddItem(g, 1, "Tree_1", -1, 1) 
    AddItem(g, 2, "Tree_2_1", -1, 1) 
    AddItem(g, 2, "Tree_2_2", -1, 2) 
    For i=0 To CountItems(g) : SetItemState(g, i, #PB_Tree_Expanded) : Next
    
    g = 15
    Gadget(g, 890+106, 230, 103, 210, #PB_Tree_AlwaysShowSelection|#BorderLess)                                         
    ;  6_example
    AddItem(g, 0, "Tree_1", -1, 1) 
    AddItem(g, 0, "Tree_2_1", -1, 2) 
    AddItem(g, 0, "Tree_2_2", -1, 3) 
    For i=0 To CountItems(g) : SetItemState(g, i, #PB_Tree_Expanded) : Next
    
    
    ;Free(g)
    
    Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
  EndIf
CompilerEndIf
; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 1235
; FirstLine = 1199
; Folding = ------
; EnableXP
; Executable = module_tree.exe