﻿Enumeration
  #Form
  #Canvas
  #Font
EndEnumeration 
 
Enumeration
  #IDC_BUTTON_SELECTED_FILE
  #IDC_BUTTON_SELECTED_FILE_INSIDE
  #IDC_BUTTON_SELECTED_FILE_OUTSIDE
  #IDC_BUTTON_SELECTED_FILE_PRESSED
EndEnumeration  
 
Procedure DrawRoundButton(isPressed.b, Text.s, X.i, Y.i, Width.i, Height.i, Shadow.b, Radius.i)
  
  Protected Result.i, Index.i, Background.i, Color.i
 
  VectorFont(FontID(#Font), 14)
 
  While (VectorTextWidth(Text) > Width)
    Text = (Left(Text, Len(Text) - Index) + "...")
    Index + 1
  Wend
  
  If (Shadow)
    For i = Radius To 1 Step -2
      MovePathCursor(X, Y + (Height / 2))
      AddPathLine(Width, 0, #PB_Path_Relative)
      VectorSourceColor(RGBA(0, 0, 0, (80 / i)))
      StrokePath(Height + i, #PB_Path_RoundEnd)
    Next 
  EndIf 
  
  MovePathCursor(X, Y + (Height / 2))
  AddPathLine(Width, 0, #PB_Path_Relative)
  
  If IsInsideStroke(GetGadgetAttribute(#Canvas, #PB_Canvas_MouseX), GetGadgetAttribute(#Canvas, #PB_Canvas_MouseY), Height, #PB_Coordinate_Device)
    Color = RGBA(255, 255, 255, 255)
    Background = RGBA(46, 204, 113, 255)
    Result = #IDC_BUTTON_SELECTED_FILE_INSIDE
    If (isPressed)
      Color = RGBA(60, 60, 60, 255)
      Background = RGBA(230, 230, 230, 255)
      Result = #IDC_BUTTON_SELECTED_FILE_PRESSED
    EndIf
  Else
    Color = RGBA(60, 60, 60, 255)
    Background = RGBA(230, 230, 230, 255)
    Result = #IDC_BUTTON_SELECTED_FILE_OUTSIDE
  EndIf
  
  VectorSourceColor(Background)
  StrokePath(Height, #PB_Path_RoundEnd)
  
  MovePathCursor((X + ((Width / 2) - (VectorTextWidth(Text) / 2))), (Y + ((Height / 2) - (VectorTextHeight(Text) / 2))))
  AddPathText(Text)
  VectorSourceColor(Color)
  FillPath()
  
  ProcedureReturn Result
  
EndProcedure  
 
Procedure CanvasUpdate(isPressed.b)
  
  Define Result = -1
  
  If StartVectorDrawing(CanvasVectorOutput(#Canvas))
      
      VectorSourceColor(RGBA(220, 220, 220, 255))
      FillVectorOutput()
 
      MovePathCursor(10, 10)
      AddPathLine(380, 0, #PB_Path_Relative)
      MovePathCursor(10, 10)
      AddPathLine(0, 180, #PB_Path_Relative)
      MovePathCursor(10, 190)
      AddPathLine(380, 0, #PB_Path_Relative)
      MovePathCursor(390, 10)
      AddPathLine(0, 180, #PB_Path_Relative)
      VectorSourceColor(RGBA(120, 120, 120, 255))
      DashPath(2, 4, #PB_Path_SquareEnd)
 
      X = (GadgetWidth(#Canvas) / 2) - 100
      Y = (GadgetHeight(#Canvas) / 2) - 15
      
      Select DrawRoundButton(isPressed, "Drag the file Or click here", X, Y, 200, 30, #True, 15)
        Case #IDC_BUTTON_SELECTED_FILE_INSIDE
          SetGadgetAttribute(#Canvas, #PB_Canvas_Cursor, #PB_Cursor_Hand)
        Case #IDC_BUTTON_SELECTED_FILE_OUTSIDE
          SetGadgetAttribute(#Canvas, #PB_Canvas_Cursor, #PB_Cursor_Default)
        Case #IDC_BUTTON_SELECTED_FILE_PRESSED
          Result = #IDC_BUTTON_SELECTED_FILE
      EndSelect    
 
      StopVectorDrawing()
    EndIf
    
    ProcedureReturn Result
EndProcedure  
 
If OpenWindow(#Form, 0, 0, 400, 200, "Example", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(#Canvas, 0, 0, 400, 200)
  LoadFont(#Font, "Tahoma", 0)
  CanvasUpdate(#False)
  Repeat
    Select WaitWindowEvent()
      Case #PB_Event_CloseWindow
        Break
      Case #PB_Event_Gadget
        Select EventGadget()
          Case #Canvas
            Select EventType()
              Case #PB_EventType_MouseMove
                CanvasUpdate(#False)
              Case #PB_EventType_LeftClick
                Select CanvasUpdate(#True)
                  Case #IDC_BUTTON_SELECTED_FILE
                    OpenFileRequester("Please choose file to load", "", "All files (*.*)|*.*", 0)
                EndSelect    
            EndSelect    
        EndSelect    
    EndSelect
  ForEver
EndIf
; IDE Options = PureBasic 5.70 LTS (Windows - x86)
; CursorPosition = 124
; FirstLine = 83
; Folding = -
; EnableXP
; CompileSourceDirectory